; SPIRITUS SANCTUS 2 (2015) for realtime Android Csound - by Arthur B. Hunkins
; Includes custom HTML5 performance GUI
; This GUI basically clones the "canonical" Android Csound5/6 GUI (5 sliders, 5 buttons, trackpad) 
; Requires Android OS 5.0 or higher, and CsoundApplication-release.apk
;   Downloadable from http://sourceforge.net/projects/csound/files/csound6/Csound6.06/  or
;   https://play.google.com/store/apps/details?id=com.csounds.Csound6 
;     OR (less recommended option)
; Android OS from 4.2.2 to < 5.0, and Csound6[.05].apk
;   Downloadable from http://sourceforge.net/projects/csound/files/csound6/Csound6.05/
; For the latter option, make these changes below:
;   all butt1 through butt5 enclosed alone in single or double quotes, to but1 through but5 (15 instances) 
;   all trackpad.x and trackpad.y (also in single or double quotes) to trackpadx & trackpady (6 instances)

<CsoundSynthesizer>
<CsOptions>

-odac -m0d

</CsOptions>
<CsInstruments>

sr      =	44100 ; Sample Rate
ksmps	=	100
nchnls  =       2

	instr 1
   
gklh    init     4
kold    init     0
k1      chnget   "butt1"
k1a     trigger  k1, .5, 0
        if k1a == 1 then
gklh    =        4
        endif
k2      chnget   "butt2"
k2a     trigger  k2, .5, 0
        if k2a == 1 then
gklh    =        5
        endif
k3      chnget   "butt3"
k3a     trigger  k3, .5, 0
        if k3a == 1 then
gklh    =        6
        endif
k4      chnget   "butt4"
k4a     trigger  k4, .5, 0
        if k4a == 1 then
gklh    =        7
        endif
k5      chnget   "butt5"
k5a     trigger  k5, .5, 0
        if k5a == 1 then
gklh    =        8
        endif
gkamp	chnget   "slider1"
gkamp   tab      gkamp * 511, 2
gkamp   =        gkamp * 12000
gkamp   port     gkamp, .2
kmul	chnget   "slider2"
kmul    =        kmul * .82
kmul    port     kmul, .2
knh	chnget   "slider3"
knh     =        (knh * 16) + 4
knh     port     knh, .2
gkrand  chnget   "trackpad.y"
gkrand  =        (gkrand == 0? kold: gkrand)
kold    =        gkrand
gkrand  =        gkrand * .6
gkrand  port     gkrand, .1
krand   rspline  -gkrand, gkrand, .6 * gklh, gklh
krand   port     krand, .01 
aout    gbuzz    gkamp + (krand * gkamp), 200, knh, gklh, kmul, 1
        outs     aout, aout * .7
        
        endin
        
        instr 2
   
kold    init     0
kmul	chnget   "slider4"
kmul    =        kmul * .82
kmul    port     kmul, .2
knh	chnget   "slider5"
knh     =        (knh * 16) + 4
knh     port     knh, .2
kfreq   chnget   "trackpad.x"
kfreq   =        (kfreq == 0? kold: kfreq)
kold    =        kfreq
kfreq   =        kfreq * .15
krand   rspline  -gkrand, gkrand, .6 * gklh, gklh
krand   port     krand, .01 
aout    gbuzz    gkamp + (krand * gkamp), 200.05 + kfreq, knh, gklh, kmul, 1
        outs     aout * .7, aout
        
        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 16 1 .012
f2 0 512 16 0 512 .8 1

i1 0 3600
i2 0 3600

</CsScore>
</CsoundSynthesizer>

<html>
<head>
<style type="text/css">

.noselect {
	-webkit-user-select: none;
}

input[type='range'] {
	-webkit-appearance: none;
	background-color: silver;
	height: 70%;
	width: 95%;
}
input[type='range']::-webkit-slider-thumb {
	-webkit-appearance: none;
	width: 10px;
	height: 120%;
	background: white;
}

table td {
	text-align: center;
	color: white;
	background-color: teal;
}

.buttons {
	width: 100%;
}        
.buttons td {
	background-color: cadetblue;
}

</style>

</head>
<body>

<div class="noselect">

<big><b>SPIRITUS SANCTUS 2 (2015)</big></b><br>
 &nbsp; Arthur B. Hunkins (arthunkins.com)

<table>
<colgroup>
  <col width="">
  <col width="100%">
</colgroup>
<tr>
<td>
	<div class="slider_height">
<label for=slider1>1 Amplitude1</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider1 step=0.001 oninput="slider1(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider2>2 MultFact1</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider2 step=0.001 oninput="slider2(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider3>3 #ofHarms1</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider3(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider4>4 MultFact2</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider4(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider5>5 #ofHarms2</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider5(value)">
</td>
</tr>
</table>

<div align="center">
Buttons - Lowest Harmonic

<table class="buttons" style="margin: auto;">
<tr>
<td>
<button class="butt_height" onclick="butt1()">Hrm4</button>
</td>
<td>
<button class="butt_height" onclick="butt2()">Hrm5</button>
</td>
<td>
<button class="butt_height" onclick="butt3()">Hrm6</button>
</td>
<td>
<button class="butt_height" onclick="butt4()">Hrm7</button>
</td>
<td>
<button class="butt_height" onclick="butt5()">Hrm8</button>
</td>
</tr>
</table>
</div>

<div align="center">
Trackpad - x=BeatFreq y=RandBeatFreq

<canvas id="trackpad" style="background-color: teal;"></canvas>
</div>

<script>

/* adjust widget dimensions (% of screen) here */
var slider_height_fraction = 0.08;
var button_height_fraction = 0.06;
var trackpad_height_fraction = 0.3;
var trackpad_width_fraction = 0.9;

/* adjust color of trackpad-when-touched  */
var trackpad_touch_color = "cadetblue";

var trackpad = document.getElementById("trackpad");
var context = trackpad.getContext('2d');
var screen_height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
var screen_width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
var elements = document.getElementsByClassName("slider_height");
Array.prototype.forEach.call(elements, function(element) {
	element.setAttribute("style", "height: "+ screen_height * slider_height_fraction +"px;");
});
var elements2 = document.getElementsByClassName("butt_height");
Array.prototype.forEach.call(elements2, function(element) {
	element.setAttribute("style", "height: "+ screen_height * button_height_fraction +"px;");
});
trackpad.width = Math.round(screen_width * trackpad_width_fraction);
trackpad.height = Math.round(screen_height * trackpad_height_fraction);

function slider1(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider1', numberValue);
}
function slider2(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider2', numberValue);
}
function slider3(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider3', numberValue);
}
function slider4(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider4', numberValue);
}
function slider5(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider5', numberValue);
}

function wait() {
        var ms = 30;  
        ms += new Date().getTime();        
        while (new Date() < ms){};
        return;
}

function butt1() {
        csound.setControlChannel('butt1', 1);
        wait();
        csound.setControlChannel('butt1', 0);
}
function butt2() {
        csound.setControlChannel('butt2', 1);
        wait();
        csound.setControlChannel('butt2', 0);
}
function butt3() {
        csound.setControlChannel('butt3', 1);
        wait();
        csound.setControlChannel('butt3', 0);
}
function butt4() {
        csound.setControlChannel('butt4', 1);
        wait();
        csound.setControlChannel('butt4', 0);
}
function butt5() {
        csound.setControlChannel('butt5', 1);
        wait();
        csound.setControlChannel('butt5', 0);
}

function getTouchPos(event) {
  var rect = trackpad.getBoundingClientRect();
  var x = Math.round((event.targetTouches[0].clientX-rect.left)/(rect.right-rect.left)*trackpad.width);
  var y = Math.round((event.targetTouches[0].clientY-rect.top)/(rect.bottom-rect.top)*trackpad.height);
  var scaled_x = x/(rect.right-rect.left);
  var scaled_y = (rect.bottom-rect.top-y)/(rect.bottom-rect.top)
  
/* delete the "if scaled_x" lines below to allow unlimited x-axis values when touch is moved beyond trackpad borders */
if (scaled_x < 0) {
	  x = 0;
	  scaled_x = 0; 
  }
  else if (scaled_x > 1) {
	  x = trackpad.width;
	  scaled_x = 1;
  }
  
/* delete the "if scaled_y" lines below to allow unlimited y-axis values when touch is moved beyond trackpad borders */
/* Note: the "canonical" Android Csound trackpad does not limit y-axis values */
if (scaled_y < 0) {
	  y = trackpad.height;
	  scaled_y = 0;
  }
  else if (scaled_y > 1) {
	  y= 0;
	  scaled_y = 1;
  }

/* always include these lines */
  return {
	x: x,
	y: y,
	scaled_x: scaled_x,
	scaled_y: scaled_y
  };
}
function doTouch(event) {
	event.preventDefault();
	var touch = getTouchPos(event);
	csound.setControlChannel('trackpad.x', touch.scaled_x);
	csound.setControlChannel('trackpad.y', touch.scaled_y);
	trackpad.style.backgroundColor=trackpad_touch_color;
}
function resetZero(event) {
	event.preventDefault();
	csound.setControlChannel('trackpad.x', 0.0);
	csound.setControlChannel('trackpad.y', 0.0);
	context.clearRect(0, 0, trackpad.width, trackpad.height);
	trackpad.style.backgroundColor="teal";
}

trackpad.addEventListener("touchstart", doTouch);
trackpad.addEventListener("touchmove", doTouch);
trackpad.addEventListener("touchend", resetZero);
	
</script>

</div>
</body>
</html>
